# Wheres The Funds - Kotlin Http4k Project

Welcome to the WheresTheFunds project! This guide covers everything you need to know about setting up, running, 
and deploying our Kotlin-based backend. We leverage the Http4k framework and kotlinx for serialization, 
tailored for efficient financial data management.

## Prerequisites

- **JDK 17**: The project uses Java 17. We recommend installing Java via [SDKMAN!](https://sdkman.io/) for easier version management.
- **Docker**: Required for running local instances of DynamoDB.
- **AWS CLI and AWS CDK**: Necessary for deployment.
- **IntelliJ IDEA**: Recommended for development.

## Local Development

### Setting Up

1. **Clone the Repository**:
   - Clone this repository to your local environment.

2. **Install Java 17 (using SDKMAN!)**:
   - If you haven't already installed SDKMAN!, follow the instructions on their [website](https://sdkman.io/).
   - Install Java 17:
     ```
     sdk install java 17.0.0-tem
     ```

3. **Configure Environment Variables**:
   - Copy `.env.example` to a new file named `.env`.
   - Set necessary environment variables, especially those related to database connections and authentication.

4. **Start Local DynamoDB**:
   - Execute `setup_local_dynamo.sh` to start a local DynamoDB instance using Docker.
   - See more in the [Local DynamoDB Setup Guide](./README.md#local-dynamodb-setup-guide)

5. **Configure Pre-Commit hooks**:
   - Run `cp pre-commit .git/hooks`

### Running the Application

- The application's entry point is defined in `WheresTheFundsBackend.kt`.
- Run locally using IntelliJ IDEA or through the Gradle command:
  ```
  ./gradlew run
  ```

## API Endpoints

- All APIs are versioned.
- Endpoints under `/api` require a valid JWT token.
- Authorization logic is in the `com.markkewley.auth` package.
- We currently support custom username/password authentication and GoogleOAuth.

## OAuth Integration

- OAuth is managed by the NextAuth frontend.
- Ensure that OAuth callback URLs and credentials are correctly set in `.env` and the NextAuth configuration.

## Deployment

1. **Build Lambda Zip**:
   - Create a deployable Lambda zip:
     ```
     ./gradlew clean buildLambdaZip
     ```

2. **Deploy with AWS CDK**:
   - Navigate to the `infrastructure` directory.
   - Use AWS CDK to deploy the resources (API Gateway, DynamoDB tables, Lambda function):
     ```
     cdk deploy
     ```
     
### Fast Deployment

If you just want to deploy lambda code without deploying the whole infrastructure we have an easy script to do so:

Say you just want to update the event lambda
-  wheres-the-funds-sqs-handler you want to update
   ```
   ./update_lambdas.sh wheres-the-funds-sqs-handler
   ```

## License

[MIT]

# Local DynamoDB Setup Guide

This guide provides instructions for setting up a local DynamoDB instance using Docker, connecting to the SQLite
database generated by DynamoDB, and configuring environment variables for the Kotlin project.

## Prerequisites

- Docker installed on your machine.
- IntelliJ IDEA for database connection setup.
- A copy of the project's `.env.example` file.

## Setting Up Local DynamoDB

1. **Run the Setup Script**:
   Execute the `setup_local_dynamo.sh` script to start a local instance of DynamoDB in a Docker container. This script
   will set up the necessary tables and configurations.
   ```
   ./setup_local_dynamo.sh
   ```

2. **SQLite Database**:
   The local DynamoDB instance will generate a `shared-local-instance.db` SQLite file located in `docker/dynamodb/`.
   This file can be used to connect to the local DynamoDB database using a database tool.

## Configuring Environment Variables

1. **.env File**:
    - Make a copy of the `.env.example` file and rename it to `.env`.
    - This file contains environment variables used by the Kotlin project.

2. **Edit .env File**:
    - Open the `.env` file in a text editor.
    - Set the `RUN_LOCAL_DYNAMO_DB` variable to `true` to enable local DynamoDB usage.
   ```
   RUN_LOCAL_DYNAMO_DB=true
   ```

## Connecting to SQLite Database in IntelliJ IDEA

1. **Open IntelliJ IDEA**:
    - Start IntelliJ IDEA and open your project.

2. **Database Tool Window**:
    - Open the Database tool window by navigating to `View -> Tool Windows -> Database`.

3. **Add a New Data Source**:
    - Click the `+` icon and select **SQLite**.

4. **Configure the Connection**:
    - In the Data Source Properties, set the following:
        - **Name**: Enter a name for the connection (e.g., Local DynamoDB).
        - **File**: Browse and select the `shared-local-instance.db` file in the `docker/dynamodb/` directory.

5. **Test the Connection**:
    - Click **Test Connection** to ensure the setup is correct.

6. **Explore and Query**:
    - Once connected, you can explore the database structure and run queries directly from IntelliJ IDEA.

## Additional Information

- The local DynamoDB instance is intended for development and testing purposes. Ensure you switch to the appropriate AWS
  DynamoDB instance for production environments.
- Regularly back up your `shared-local-instance.db` file if you store important data in the local DynamoDB instance.
- Refer to the official DynamoDB and Docker documentation for more advanced configurations and troubleshooting.
- For more information about DynamoDB Local see the AWS docs [here](https://docs.aws.amazon.com/amazondynamodb/latest/developerguide/DynamoDBLocal.DownloadingAndRunning.html#docker)